
(function(){

var coauthors_table = null;

var coauthorsTable = jQuery('#coauthors-table');
var editing = false;

/*
 * Get an author's name from their ID
 * Iterates through the coauthors-select input box until finds the entry with the associated ID
 *
 */
function coauthors_get_author_name( authorID ) {
	var select = jQuery('#coauthors-select');
	
	if(authorID){
		//Find the provided author ID
		var name = "";
		select.find("option").each(function(i){
			if(this.value == authorID) {
				name = this.innerHTML;
				return;
			}

		});
		return name;
	}
	return false;

}


function coauthors_select_author( authorID, selectID ) {
	if(!selectID) selectID = '#coauthors-select';

	var select = jQuery(selectID);
	
	if(authorID){
		//Find the provided author ID
		select.find("option").each(function(i){
			if(this.value == authorID) {
				jQuery(this).attr('selected','true')
				return false;
			}
		});
	}

}

function coauthors_remove_author( authorName ) {
	var select = jQuery('#coauthors-select');
	if(authorName){
		//Find the provided author ID
		select.find("option").each(function(i){
			if(this.innerHTML == authorName) {
				jQuery(this).removeAttr('selected');
				return true;
			}
		});
	}
}

// Old function not needed; though may be useful for duplicate validation 
var coauthors_select_onchange = function(event){

};

var coauthors_delete_onclick = function(event){
	
	if(confirm('Are you sure you want to delete this author?')) {
		var tr = jQuery(this).parent().parent();
		var name = tr.find('span.author-tag').text();
		coauthors_remove_author(name);
		tr.remove();
		
		return true;
	}
	return false;
};

function coauthors_insert_author_edit_cells(tr){
	
	var deleteBtn = jQuery('<span></span>')
						.addClass('delete-coauthor')
						.text('Delete')
						.bind('click', coauthors_delete_onclick)
						;
	
	var td = jQuery('<td></td>')
				.addClass('delete')
				;
	td.append(deleteBtn);
	jQuery(tr).append(td);
	return tr;		
						
}

function coauthors_save_coauthor(authorID, authorName, co) {

	coauthors_remove_author(co.next().text());
	
	// get sibling <span>, update, and hide
	co.next().html(authorName)
				.show()
				;
	
	// select new author
	if(co.attr('name')=='coauthors-main') {
		coauthors_select_author( authorID, '#post_author_override' );
	} else { 
		coauthors_select_author( authorID )
	}
	
	editing = false; 
}



function coauthors_add_coauthor(authorID, authorName, co, init){
	var selectedIndex = -1;
	
	if(editing) {
		coauthors_save_coauthor(authorID, authorName, co)
	
	} else {
		
		if(!co) var co = coauthors_create_autosuggest(authorName)
		var tag = coauthors_create_author_tag(authorName);
	
		coauthors_add_to_table(co, tag);
		
		// Add new author to <select>
		coauthors_select_author( authorID )
			
		if(!init) {
			// Create new author-suggest and append it to a new row
			var newCO = coauthors_create_autosuggest('', false);
			coauthors_add_to_table(newCO);
		}
	}
	
	co.bind('blur', coauthors_stop_editing);
	
	// Set the value for the auto-suggest box to the Author's name and hide it
	co.val(authorName)
	  .hide()
	  .unbind('focus')
	  ;
	
	return true;
}


function coauthors_add_to_table( co, tag, del ) {
	if(co) {
		var td = jQuery('<td></td>');
		td.className = 'suggest';
		td.append(co);
		td.append(tag);
		var tr = jQuery('<tr></tr>');
		tr.append(td);

		//Add buttons to row
		if(tag && !del) coauthors_insert_author_edit_cells(tr);
		
		jQuery('#coauthors-table').append(tr);
	}
}

function coauthors_create_autosuggest(authorName, inputName) {

	if(!inputName) inputName = 'coauthors2[]';

	var co = jQuery('<input/>')
							.attr({
								'class': 'coauthor-suggest',
								'name': inputName
								})
							.appendTo(div)
							
							.suggest(coauthor_ajax_suggest_link,{
								onSelect: 
									function() {
										
										var vals = this.value.split("|");
																				
										var id = jQuery.trim(vals[0]);
										var name = jQuery.trim(vals[1]);
										
										if(id=="New") {
											alert('Eventually, this will allow you to add a new author right from here. But it\'s not ready yet. *sigh*');
										} else {
											coauthors_add_coauthor(id, name, co);
										}
									}
							})
							.keydown(function(e) {
								if(e.keyCode == 13) {return false;}

							})
							;
								
	if(authorName)
		co.attr('value', authorName);
	else
		co.attr('value', 'Search for an author')
					.focus(function(){co.val('')})
					.blur(function(){co.val('Search for an author')})
					;
	
	return co;

}

function coauthors_stop_editing(event) {
	var co = jQuery(event.target);
	var tag = jQuery(co.next());
	
	co.attr('value',tag.text());

	co.hide();
	tag.show();
	editing = false;
}

function coauthors_create_author_tag (name) {
	var tag = jQuery('<span></span>')
						.html(name)
						.attr('title', 'Click to edit')
						.addClass('author-tag')
						// Add Click event to edit
						.click(function(){
							if(!editing) {
								editing = true;
								
								var co = tag.prev();
								
								tag.hide();
								co.show()
									.focus()
									;
								
								co.previousAuthor = tag.text();
							}
							
						});

	return tag;
}


if(document.getElementById('post_author_override')){
	if(!coauthors_can_edit_others_posts){
		jQuery('#authordiv, #pageauthordiv').remove();
		return;
	}

	//Note that there can be co-authors (changes dbx title from "Post Author" to "Post Author(s)")
	var h3 = jQuery('#authordiv :header, #pageauthordiv :header').html(
			/page[^\/]+$/.test(window.location.href) ?
				coauthors_dbx_page_title
			:
				coauthors_dbx_post_title
	);
	
	//Add the controls to add co-authors
	var div = jQuery('#authordiv div, #pageauthordiv div').filter(function(){
		if(jQuery(this).is('.inside') || jQuery(this).is('.dbx-content'))
			return true;
		return false;
	})[0];
	
	if(div){
	
		var table = jQuery('<table></table>')
								.attr('id', 'coauthors-table')
								;
		
		var coauthors_table = jQuery('<tbody></tbody>')
										.appendTo(table)
										;
		
		var tr = jQuery('<tr></tr>');
		var td = jQuery('<td></td>')
							.addClass('select')
							;
				
		var select = jQuery('#post_author_override')[0];
				
		td.append(select);
		tr.append(td);
		coauthors_table.append(tr);
		jQuery(div).append(table);

		// Create input and span for first entry
		var nameFirst = select[select.selectedIndex].innerHTML;
		var coFirst = coauthors_create_autosuggest(nameFirst, 'coauthors-main')
		coFirst.hide();
		var tagFirst = coauthors_create_author_tag(nameFirst);
		jQuery(select).after(tagFirst)
			  		  .after(coFirst)
			  		  ;
		// Add blur event to suggest box 
		coFirst.bind('blur', coauthors_stop_editing);
		
		// Create coauthors select box by cloning it from the drop-down				
		var coauthors = jQuery('#post_author_override').clone(true)
			                                            .attr('id', 'coauthors-select')
			                                            .attr('name', 'coauthors[]')
			                                            .attr({'multiple':'multiple', 'size':5})
			                                            .attr('style','height:10em')
			                                            .attr('selectedIndex', '-1')
			                                            ;
		coauthors.insertAfter('#post_author_override');
		
		// Hide both select boxes
		jQuery('#post_author_override').hide();
		coauthors.hide();
		
		var help = jQuery('<p></p>').text('Click on an author to edit. Click on "Delete" to remove them.');		
		jQuery('#authordiv .inside').append(help);

		var presenceInput;
		try {
			//For MSIE
			presenceInput = document.createElement('<input name="coauthors_plugin_is_active" type="hidden" value="1" />');
			if(!presenceInput || presenceInput.name != 'coauthors_plugin_is_active')
				throw Error();
		} catch(e){
			presenceInput = document.createElement('input');
			presenceInput.name = "coauthors_plugin_is_active";
			presenceInput.value = 1;
			presenceInput.type = 'hidden';
		}
		div.appendChild(presenceInput);
	}
	
	// Select authors already added to the post
	var addedAlready = {};
	jQuery('#the-list tr').each(function(){
		var userID = jQuery(this).find('textarea').val();
		if(jQuery(this).find("input[@value='_coauthor']").length && !addedAlready[userID]){
			var authorName = coauthors_get_author_name(userID);
			if(authorName) coauthors_add_coauthor(userID, authorName, undefined, true );	
			addedAlready[userID] = true;
		}
	});
	
	// Create new author-suggest and append it to a new row
	var newCO = coauthors_create_autosuggest('', false);
	coauthors_add_to_table(newCO);

}

})();
