<?php
/**
 * Bootstrap for getting the ABSPATH constant to wp-load.php
 * This is requried when a plugin requires access not via the admin screen.
 *
 * If the wp-load.php file is not found, then an error will be displayed
 *
 */
 
/** Define the server path to the file wp-config here, if you placed WP-CONTENT outside the classic file structure */

$path  = ''; // It should be end with a trailing slash    

/** That's all, stop editing from here **/

if ( !defined('WP_LOAD_PATH') ) {

	/** classic root path if wp-content and plugins is below wp-config.php */
	$classic_root = dirname(dirname(dirname(dirname(__FILE__)))) . '/' ;
	
	if (file_exists( $classic_root . 'wp-load.php') )
		define( 'WP_LOAD_PATH', $classic_root);
	else
		if (file_exists( $path . 'wp-load.php') )
			define( 'WP_LOAD_PATH', $path);
		else
			exit("Could not find wp-load.php");
}

// let's load WordPress
require_once( WP_LOAD_PATH . 'wp-load.php');


/**
 * Returns a listing of users based on search string.
 * Searches through user's login, full name, display name, and email for string match
 *
 */
function coauthors_ajax_suggest() {
	
	global $wpdb;
	
	$q = '%'.strtolower($_REQUEST["q"]).'%';
	if (!$q) return;
	
	// 
	$authors_query = $wpdb->prepare("SELECT ID, display_name, user_email 
									FROM $wpdb->users 
									WHERE ID = ANY (SELECT user_id FROM $wpdb->usermeta WHERE meta_key = 'wp_user_level' AND meta_value >= 1)
									AND (user_login LIKE %s 
									OR user_nicename LIKE %s 
									OR display_name LIKE %s 
									OR user_email LIKE %s)",$q,$q,$q,$q
									);
	
	$authors = $wpdb->get_results($authors_query, ARRAY_A);

	if(is_array($authors)) {
		foreach ($authors as $author) {
			
			echo $author['ID']." | ". $author['display_name'] ." | ".$author['user_email'] ."\n";
		}
	}
	//echo "New | Add new author: ".trim($q,'%')."\n";
}

// Make sure that user is logged in; we don't want to enable direct access
get_currentuserinfo();
global $user_level;
if ($user_level >= 7) coauthors_ajax_suggest();
